diff --git a/url/ipc/url_ipc_export.h b/url/ipc/url_ipc_export.h
index 1da0fa6854b9..a24821a2a8dc 100644
--- a/url/ipc/url_ipc_export.h
+++ b/url/ipc/url_ipc_export.h
@@ -9,20 +9,30 @@
 #if defined(WIN32)
 
 #if defined(URL_IPC_IMPLEMENTATION)
+#define SUSPICIOUS_EXTENSION_ACTION_IPC_EXPORT __declspec(dllexport)
+#define SENSITIVE_ELEMENT_IPC_EXPORT __declspec(dllexport)
 #define URL_IPC_EXPORT __declspec(dllexport)
 #else
+#define SUSPICIOUS_EXTENSION_ACTION_IPC_EXPORT __declspec(dllimport)
+#define SENSITIVE_ELEMENT_IPC_EXPORT __declspec(dllimport)
 #define URL_IPC_EXPORT __declspec(dllimport)
 #endif  // defined(URL_IPC_IMPLEMENTATION)
 
 #else  // defined(WIN32)
 #if defined(URL_IPC_IMPLEMENTATION)
+#define SUSPICIOUS_EXTENSION_ACTION_IPC_EXPORT __attribute__((visibility("default")))
+#define SENSITIVE_ELEMENT_IPC_EXPORT __attribute__((visibility("default")))
 #define URL_IPC_EXPORT __attribute__((visibility("default")))
 #else
+#define SUSPICIOUS_EXTENSION_ACTION_IPC_EXPORT
+#define SENSITIVE_ELEMENT_IPC_EXPORT
 #define URL_IPC_EXPORT
 #endif
 #endif
 
 #else  // defined(COMPONENT_BUILD)
+#define SUSPICIOUS_EXTENSION_ACTION_IPC_EXPORT
+#define SENSITIVE_ELEMENT_IPC_EXPORT
 #define URL_IPC_EXPORT
 #endif
 
diff --git a/url/ipc/url_param_traits.cc b/url/ipc/url_param_traits.cc
index b41e4716204f..a15d695e7082 100644
--- a/url/ipc/url_param_traits.cc
+++ b/url/ipc/url_param_traits.cc
@@ -8,6 +8,16 @@
 
 namespace IPC {
 
+void ParamTraits<SuspiciousExtensionAction>::GetSize(base::PickleSizer* s, const SuspiciousExtensionAction& p) {
+  uint16_t i;
+  GetParamSize(s, i);
+}
+
+void ParamTraits<SensitiveElement>::GetSize(base::PickleSizer* s, const SensitiveElement& p) {
+  uint16_t i;
+  GetParamSize(s, i);
+}
+
 void ParamTraits<GURL>::GetSize(base::PickleSizer* s, const GURL& p) {
   if (p.possibly_invalid_spec().length() > url::kMaxURLChars || !p.is_valid()) {
     GetParamSize(s, std::string());
@@ -17,6 +27,14 @@ void ParamTraits<GURL>::GetSize(base::PickleSizer* s, const GURL& p) {
   GetParamSize(s, p.possibly_invalid_spec());
 }
 
+void ParamTraits<SuspiciousExtensionAction>::Write(base::Pickle* m, const SuspiciousExtensionAction& p) {
+  m->WriteUInt16(static_cast<uint16_t>(p));
+}
+
+void ParamTraits<SensitiveElement>::Write(base::Pickle* m, const SensitiveElement& p) {
+  m->WriteUInt16(static_cast<uint16_t>(p));
+}
+
 void ParamTraits<GURL>::Write(base::Pickle* m, const GURL& p) {
   if (p.possibly_invalid_spec().length() > url::kMaxURLChars) {
     m->WriteString(std::string());
@@ -38,6 +56,30 @@ void ParamTraits<GURL>::Write(base::Pickle* m, const GURL& p) {
   // TODO(brettw) bug 684583: Add encoding for query params.
 }
 
+bool ParamTraits<SuspiciousExtensionAction>::Read(const base::Pickle* m,
+                                                  base::PickleIterator* iter,
+                                                  SuspiciousExtensionAction* p) {
+  uint16_t s;
+  if (iter->ReadUInt16(&s)) {
+    *p = static_cast<SuspiciousExtensionAction>(s);
+    return true;
+  } else {
+    return false;
+  }
+}
+
+bool ParamTraits<SensitiveElement>::Read(const base::Pickle* m,
+                                         base::PickleIterator* iter,
+                                         SensitiveElement* p) {
+  uint16_t s;
+  if (iter->ReadUInt16(&s)) {
+    *p = static_cast<SensitiveElement>(s);
+    return true;
+  } else {
+    return false;
+  }
+}
+
 bool ParamTraits<GURL>::Read(const base::Pickle* m,
                              base::PickleIterator* iter,
                              GURL* p) {
@@ -54,6 +96,10 @@ bool ParamTraits<GURL>::Read(const base::Pickle* m,
   return true;
 }
 
+void ParamTraits<SuspiciousExtensionAction>::Log(const SuspiciousExtensionAction& p, std::string* l) {}
+
+void ParamTraits<SensitiveElement>::Log(const SensitiveElement& p, std::string* l) {}
+
 void ParamTraits<GURL>::Log(const GURL& p, std::string* l) {
   l->append(p.spec());
 }
diff --git a/url/ipc/url_param_traits.h b/url/ipc/url_param_traits.h
index 8db402948461..b31866877a28 100644
--- a/url/ipc/url_param_traits.h
+++ b/url/ipc/url_param_traits.h
@@ -12,6 +12,28 @@
 namespace IPC {
 
 template <>
+struct SUSPICIOUS_EXTENSION_ACTION_IPC_EXPORT ParamTraits<SuspiciousExtensionAction> {
+  typedef SuspiciousExtensionAction param_type;
+  static void GetSize(base::PickleSizer* s, const param_type& p);
+  static void Write(base::Pickle* m, const param_type& p);
+  static bool Read(const base::Pickle* m,
+                   base::PickleIterator* iter,
+                   param_type* p);
+  static void Log(const param_type& p, std::string* l);
+};
+
+template <>
+struct SENSITIVE_ELEMENT_IPC_EXPORT ParamTraits<SensitiveElement> {
+  typedef SensitiveElement param_type;
+  static void GetSize(base::PickleSizer* s, const param_type& p);
+  static void Write(base::Pickle* m, const param_type& p);
+  static bool Read(const base::Pickle* m,
+                   base::PickleIterator* iter,
+                   param_type* p);
+  static void Log(const param_type& p, std::string* l);
+};
+
+template <>
 struct URL_IPC_EXPORT ParamTraits<GURL> {
   typedef GURL param_type;
   static void GetSize(base::PickleSizer* s, const param_type& p);
